
    /**
     * 描述：周期季度 单据头表单校验
     */
    shr.defineClass("shr.custom.ExamineGradePersonZQJDEdit", shr.framework.Edit, {

        /**
         * 描述:初始化操作
         * 
         * @action
         */
        initalizeDOM: function () {
            var _self = this;
            shr.custom.ExamineGradePersonZQJDEdit.superClass.initalizeDOM.call(this);
        
        },
        backAction(){
            var billId = this.getSelectedIds();
            this.reloadPage({
                uipk: "com.kingdee.eas.custom.performancenew.app.ExamineGradePerson.list",
                billId: billId,
            });
        },
        /**
         * 保存
         */
        saveAction: function (event) {
            $("#entrys").jqGrid("editStop");
            var periodType = $("#periodType").val();
            var year = $("#year").val();
            if (periodType == "年度") {
                var validYear = this.validateYear(year);
                if (!validYear) {
                    shr.showWarning({
                        message: '请输入有效年',
                        history: 2

                    });
                    return;
                }
            } else {
                var quarter = $("#quarter").val();
                var validYearMonth = this.validateYearMonth(year, quarter);
                if (!validYearMonth) {
                    shr.showWarning({
                        message: '请输入有效年或季度',
                        history: 2
                    });
                    return;
                }
            }
            shr.custom.ExamineGradePersonZQJDEdit.superClass.saveAction.call(this);
        },



        /**
         * 校验有效年
         */
        validateYear: function (year) {
            // 验证年份和月份的格式
            var yearPattern = /^\d{4}$/;
            if (!yearPattern.test(year)) {
                return false; // 年份或者月份格式不正确
            }

            // 构建 Date 对象
            var date = new Date(year);

            // 校验日期的有效性
            if (date.getFullYear() !== parseInt(year)) {
                return false; // 日期不在该年月的有效范围内
            }

            return true; // 年有效
        },
        /**
             * 校验是否有效年或季度
             */
        validateYearMonth: function (year, month) {
            // 验证年份和月份的格式
            var yearPattern = /^\d{4}$/;
            var monthPattern = /^[1-4]$/;

            if (!yearPattern.test(year) || !monthPattern.test(month)) {
                return false; // 年份或者月份格式不正确
            }

            // 构建 Date 对象
            var date = new Date(year);

            // 校验日期的有效性
            if (date.getFullYear() !== parseInt(year)) {
                return false; // 日期不在该年月的有效范围内
            }

            return true; // 年月有效
        }
    });
